Index: src/s_serv.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/src/s_serv.c,v
retrieving revision 7.406.2.2
diff -b -u -r7.406.2.2 s_serv.c
--- src/s_serv.c	4 Aug 2004 00:21:17 -0000	7.406.2.2
+++ src/s_serv.c	19 Aug 2004 22:16:44 -0000
@@ -87,18 +87,19 @@
  */
 struct Capability captab[] = {
 /*  name     cap     */
-	{ "QS",		CAP_QS },
-	{ "EX",		CAP_EX },
-	{ "CHW",	CAP_CHW},
-	{ "IE", 	CAP_IE},
-	{ "KLN",	CAP_KLN},
-	{ "GLN",	CAP_GLN},
-	{ "KNOCK",	CAP_KNOCK},
-	{ "ZIP",	CAP_ZIP},
-	{ "TB",		CAP_TB},
-	{ "UNKLN",	CAP_UNKLN},
-	{ "CLUSTER",	CAP_CLUSTER},
-	{ "ENCAP",	CAP_ENCAP },
+	{"QS", CAP_QS},
+	{"EX", CAP_EX},
+	{"CHW", CAP_CHW},
+	{"IE", CAP_IE},
+	{"KLN", CAP_KLN},
+	{"GLN", CAP_GLN},
+	{"KNOCK", CAP_KNOCK},
+	{"ZIP", CAP_ZIP},
+	{"TB", CAP_TB},
+	{"UNKLN", CAP_UNKLN},
+	{"CLUSTER", CAP_CLUSTER},
+	{"ENCAP", CAP_ENCAP},
+	{"HOPS", CAP_HOPS},
 	{0, 0}
 };
 
@@ -294,8 +295,7 @@
 		{
 			if(!IsDigit(parv[server][0]))
 				sendto_one_numeric(source_p, ERR_NOSUCHSERVER,
-						   form_str(ERR_NOSUCHSERVER),
-						   parv[server]);
+						   form_str(ERR_NOSUCHSERVER), parv[server]);
 			return (HUNTED_NOSUCH);
 		}
 		else
@@ -318,8 +318,7 @@
 		if(!IsRegistered(target_p))
 		{
 			sendto_one_numeric(source_p, ERR_NOSUCHSERVER,
-					   form_str(ERR_NOSUCHSERVER),
-					   parv[server]);
+					   form_str(ERR_NOSUCHSERVER), parv[server]);
 			return HUNTED_NOSUCH;
 		}
 
@@ -426,12 +425,9 @@
 	 */
 #ifndef HIDE_SERVERS_IPS
 	sendto_realops_flags(UMODE_ALL, L_ALL,
-			"Connection to %s[%s] activated.",
-			server_p->name, server_p->host);
+			     "Connection to %s[%s] activated.", server_p->name, server_p->host);
 #else
-	sendto_realops_flags(UMODE_ALL, L_ALL,
-			"Connection to %s activated",
-			server_p->name);
+	sendto_realops_flags(UMODE_ALL, L_ALL, "Connection to %s activated", server_p->name);
 #endif
 
 	serv_connect(server_p, 0);
@@ -469,8 +465,7 @@
 
 		/* XXX: Fix me for IPv6 */
 		/* XXX sockhost is the IPv4 ip as a string */
-		if(match(tmp_p->host, client_p->host) ||
-		   match(tmp_p->host, client_p->sockhost))
+		if(match(tmp_p->host, client_p->host) || match(tmp_p->host, client_p->sockhost))
 		{
 			error = -2;
 
@@ -508,10 +503,10 @@
 #ifdef IPV6
 	if(client_p->localClient->ip.ss_family == AF_INET6)
 	{
-		if(IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&server_p->ipnum)->sin6_addr))
+		if(IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *) &server_p->ipnum)->sin6_addr))
 		{
-			memcpy(&((struct sockaddr_in6 *)&server_p->ipnum)->sin6_addr, 
-				&((struct sockaddr_in6 *)&client_p->localClient->ip)->sin6_addr, 
+			memcpy(&((struct sockaddr_in6 *) &server_p->ipnum)->sin6_addr,
+			       &((struct sockaddr_in6 *) &client_p->localClient->ip)->sin6_addr,
 				sizeof(struct in6_addr)); 
 			SET_SS_LEN(server_p->ipnum, sizeof(struct sockaddr_in6));
 		} 
@@ -519,10 +514,11 @@
 	else
 #endif
 	{
-		if(((struct sockaddr_in *)&server_p->ipnum)->sin_addr.s_addr == INADDR_NONE)
+		if(((struct sockaddr_in *) &server_p->ipnum)->sin_addr.s_addr == INADDR_NONE)
 		{
-			((struct sockaddr_in *)&server_p->ipnum)->sin_addr.s_addr = 
-				((struct sockaddr_in *)&client_p->localClient->ip)->sin_addr.s_addr;
+			((struct sockaddr_in *) &server_p->ipnum)->sin_addr.s_addr =
+				((struct sockaddr_in *) &client_p->localClient->ip)->sin_addr.
+				s_addr;
 		}
 		SET_SS_LEN(server_p->ipnum, sizeof(struct sockaddr_in));
 	}
@@ -549,7 +545,7 @@
 
 	t = msgbuf;
 
-	for (cap = captab; cap->name; ++cap)
+	for(cap = captab; cap->name; ++cap)
 	{
 		if(cap->cap & cap_can_send)
 		{
@@ -571,7 +567,7 @@
  * side effects - client is sent a list of +b, or +e, or +I modes
  */
 static void
-burst_modes_TS5(struct Client *client_p, char *chname, dlink_list *list, char flag)
+burst_modes_TS5(struct Client *client_p, char *chname, dlink_list * list, char flag)
 {
 	dlink_node *ptr;
 	struct Ban *banptr;
@@ -627,8 +623,7 @@
  * side effects - client is sent a list of +b, +e, or +I modes
  */
 static void
-burst_modes_TS6(struct Client *client_p, struct Channel *chptr, 
-		dlink_list *list, char flag)
+burst_modes_TS6(struct Client *client_p, struct Channel *chptr, dlink_list * list, char flag)
 {
 	dlink_node *ptr;
 	struct Ban *banptr;
@@ -658,7 +653,7 @@
 			}
 
 			/* chop off trailing space and send.. */
-			*(t-1) = '\0';
+			*(t - 1) = '\0';
 			sendto_one(client_p, "%s", buf);
 			cur_len = mlen;
 			t = buf + mlen;
@@ -672,7 +667,7 @@
 	/* cant ever exit the loop above without having modified buf,
 	 * chop off trailing space and send.
 	 */
-	*(t-1) = '\0';
+	*(t - 1) = '\0';
 	sendto_one(client_p, "%s", buf);
 }
 
@@ -721,8 +716,7 @@
 			   target_p->user->server, target_p->info);
 
 		if(ConfigFileEntry.burst_away && !EmptyString(target_p->user->away))
-			sendto_one(client_p, ":%s AWAY :%s",
-				   target_p->name, target_p->user->away);
+			sendto_one(client_p, ":%s AWAY :%s", target_p->name, target_p->user->away);
 	}
 
 	DLINK_FOREACH(ptr, global_channel_list.head)
@@ -744,7 +738,8 @@
 		channel_modes(chptr, client_p, modebuf, parabuf);
 
 		cur_len = mlen = ircsprintf(buf, ":%s SJOIN %ld %s %s %s:", me.name,
-				(long) chptr->channelts, chptr->chname, modebuf, parabuf);
+					    (long) chptr->channelts, chptr->chname, modebuf,
+					    parabuf);
 
 		t = buf + mlen;
 
@@ -755,6 +750,8 @@
 			tlen = strlen(msptr->client_p->name) + 1;
 			if(is_chanop(msptr))
 				tlen++;
+			if(is_halfop(msptr))
+				tlen++;
 			if(is_voiced(msptr))
 				tlen++;
 
@@ -767,8 +764,9 @@
 				t = buf + mlen;
 			}
 
-			ircsprintf(t, "%s%s ", find_channel_status(msptr, 1), 
-				   msptr->client_p->name);
+			ircsprintf(t, "%s%s ", find_channel_status(msptr, 1,
+								   (IsCapable(client_p, CAP_HOPS)) ?
+								   1 : 0), msptr->client_p->name);
 
 			cur_len += tlen;
 			t += tlen;
@@ -791,8 +789,7 @@
 			sendto_one(client_p, ":%s TB %s %ld %s%s:%s",
 				   me.name, chptr->chname, (long) chptr->topic_time,
 				   ConfigChannel.burst_topicwho ? chptr->topic_info : "",
-				   ConfigChannel.burst_topicwho ? " " : "",
-				   chptr->topic);
+				   ConfigChannel.burst_topicwho ? " " : "", chptr->topic);
 	}
 }
 
@@ -853,8 +850,7 @@
 
 		if(ConfigFileEntry.burst_away && !EmptyString(target_p->user->away))
 			sendto_one(client_p, ":%s AWAY :%s",
-				   use_id(target_p),
-				   target_p->user->away);
+				   use_id(target_p), target_p->user->away);
 	}
 
 	DLINK_FOREACH(ptr, global_channel_list.head)
@@ -876,7 +872,8 @@
 		channel_modes(chptr, client_p, modebuf, parabuf);
 
 		cur_len = mlen = ircsprintf(buf, ":%s SJOIN %ld %s %s %s:", me.name,
-				(long) chptr->channelts, chptr->chname, modebuf, parabuf);
+					    (long) chptr->channelts, chptr->chname, modebuf,
+					    parabuf);
 
 		t = buf + mlen;
 
@@ -887,18 +884,22 @@
 			tlen = strlen(use_id(msptr->client_p)) + 1;
 			if(is_chanop(msptr))
 				tlen++;
+			if(is_halfop(msptr))
+				tlen++;
 			if(is_voiced(msptr))
 				tlen++;
 
 			if(cur_len + tlen >= BUFSIZE - 3)
 			{
-				*(t-1) = '\0';
+				*(t - 1) = '\0';
 				sendto_one(client_p, "%s", buf);
 				cur_len = mlen;
 				t = buf + mlen;
 			}
 
-			ircsprintf(t, "%s%s ", find_channel_status(msptr, 1), 
+			ircsprintf(t, "%s%s ", find_channel_status(msptr, 1,
+								   (IsCapable(client_p, CAP_HOPS) ?
+								    1 : 0)),
 				   use_id(msptr->client_p));
 
 			cur_len += tlen;
@@ -906,26 +907,23 @@
 		}
 
 		/* remove trailing space */
-		*(t-1) = '\0';
+		*(t - 1) = '\0';
 		sendto_one(client_p, "%s", buf);
 
 		if(dlink_list_length(&chptr->banlist) > 0)
 			burst_modes_TS6(client_p, chptr, &chptr->banlist, 'b');
 
-		if(IsCapable(client_p, CAP_EX) &&
-		   dlink_list_length(&chptr->exceptlist) > 0)
+		if(IsCapable(client_p, CAP_EX) && dlink_list_length(&chptr->exceptlist) > 0)
 			burst_modes_TS6(client_p, chptr, &chptr->exceptlist, 'e');
 
-		if(IsCapable(client_p, CAP_IE) &&
-		   dlink_list_length(&chptr->invexlist) > 0)
+		if(IsCapable(client_p, CAP_IE) && dlink_list_length(&chptr->invexlist) > 0)
 			burst_modes_TS6(client_p, chptr, &chptr->invexlist, 'I');
 
 		if(IsCapable(client_p, CAP_TB) && chptr->topic != NULL)
 			sendto_one(client_p, ":%s TB %s %ld %s%s:%s",
 				   me.id, chptr->chname, (long) chptr->topic_time,
 				   ConfigChannel.burst_topicwho ? chptr->topic_info : "",
-				   ConfigChannel.burst_topicwho ? " " : "",
-				   chptr->topic);
+				   ConfigChannel.burst_topicwho ? " " : "", chptr->topic);
 	}
 }
 
@@ -956,7 +954,7 @@
 		return msgbuf;
 	}
 
-	for (cap = captab; cap->cap; ++cap)
+	for(cap = captab; cap->cap; ++cap)
 	{
 		if(cap->cap & target_p->serv->caps)
 		{
@@ -1042,8 +1040,7 @@
 				sendto_one(client_p, "PASS %s TS %d :%s", 
 					   server_p->spasswd, TS_CURRENT, me.id);
 			else
-				sendto_one(client_p, "PASS %s :TS",
-					   server_p->spasswd);
+				sendto_one(client_p, "PASS %s :TS", server_p->spasswd);
 		}
 
 		/* pass info to new server */
@@ -1122,8 +1119,7 @@
 	/* Show the real host/IP to admins */
 	sendto_realops_flags(UMODE_ALL, L_ALL,
 			"Link with %s established: (%s) link",
-			get_server_name(client_p, SHOW_IP),
-			show_capabilities(client_p));
+			     get_server_name(client_p, SHOW_IP), show_capabilities(client_p));
 
 	ilog(L_SERVER, "Link with %s established: (%s) link",
 	     log_client_name(client_p, SHOW_IP), show_capabilities(client_p));
@@ -1157,8 +1153,7 @@
 				   me.id, client_p->name, client_p->id,
 				   IsHidden(client_p) ? "(H) " : "", client_p->info);
 
-			if(IsCapable(target_p, CAP_ENCAP) &&
-			   !EmptyString(client_p->serv->fullcaps))
+			if(IsCapable(target_p, CAP_ENCAP) && !EmptyString(client_p->serv->fullcaps))
 				sendto_one(target_p, ":%s ENCAP * GCAP :%s",
 					client_p->id, client_p->serv->fullcaps);
 		}
@@ -1168,8 +1163,7 @@
 				   me.name, client_p->name,
 				   IsHidden(client_p) ? "(H) " : "", client_p->info);
 
-			if(IsCapable(target_p, CAP_ENCAP) &&
-			   !EmptyString(client_p->serv->fullcaps))
+			if(IsCapable(target_p, CAP_ENCAP) && !EmptyString(client_p->serv->fullcaps))
 				sendto_one(target_p, ":%s ENCAP * GCAP :%s",
 					client_p->name, client_p->serv->fullcaps);
 		}
@@ -1213,11 +1207,9 @@
 				   target_p->name, target_p->hopcount + 1,
 				   IsHidden(target_p) ? "(H) " : "", target_p->info);
 
-		if(IsCapable(client_p, CAP_ENCAP) && 
-		   !EmptyString(target_p->serv->fullcaps))
+		if(IsCapable(client_p, CAP_ENCAP) && !EmptyString(target_p->serv->fullcaps))
 			sendto_one(client_p, ":%s ENCAP * GCAP :%s",
-					get_id(target_p, client_p),
-					target_p->serv->fullcaps);
+				   get_id(target_p, client_p), target_p->serv->fullcaps);
 	}
 
 	if(has_id(client_p))
@@ -1252,7 +1244,7 @@
 		iobuf[c++] = SLINKCMD_START_ZIP_OUT;
 	}
 
-	while (MyConnect(server))
+	while(MyConnect(server))
 	{
 		linecount++;
 
@@ -1272,16 +1264,14 @@
 			break;
 	}
 
-	while (MyConnect(server))
+	while(MyConnect(server))
 	{
 		linecount++;
 
 		iobuf = MyRealloc(iobuf, (c + BUF_DATA_SIZE + 64));
 
 		/* store data in c+3 to allow for SLINKCMD_INJECT_RECVQ and len u16 */
-		linelen = linebuf_get(&server->localClient->buf_sendq, 
-				      (char *) (iobuf + c + 3), READBUF_SIZE, 
-				      LINEBUF_PARTIAL, LINEBUF_PARSED);	/* include partial lines */
+		linelen = linebuf_get(&server->localClient->buf_sendq, (char *) (iobuf + c + 3), READBUF_SIZE, LINEBUF_PARTIAL, LINEBUF_PARSED);	/* include partial lines */
 
 		if(linelen)
 		{
@@ -1330,7 +1320,7 @@
 #ifdef HAVE_SOCKETPAIR
 	if(socketpair(AF_UNIX, SOCK_STREAM, 0, ctrl_fds) < 0)
 #else
-	if(inet_socketpair(AF_INET,SOCK_STREAM, 0, ctrl_fds) < 0)
+	if(inet_socketpair(AF_INET, SOCK_STREAM, 0, ctrl_fds) < 0)
 #endif
 		goto fork_error;
 
@@ -1340,7 +1330,7 @@
 #ifdef HAVE_SOCKETPAIR
 	if(socketpair(AF_UNIX, SOCK_STREAM, 0, data_fds) < 0)
 #else
-	if(inet_socketpair(AF_INET,SOCK_STREAM, 0, data_fds) < 0)
+	if(inet_socketpair(AF_INET, SOCK_STREAM, 0, data_fds) < 0)
 #endif
 		goto fork_error;
 
@@ -1354,11 +1344,12 @@
 	else if(ret == 0)
 	{
 		/* set our fds as non blocking and close everything else */
-		for (i = 0; i < HARD_FDLIMIT; i++)
+		for(i = 0; i < HARD_FDLIMIT; i++)
 		{
 				
 
-			if((i == ctrl_fds[1]) || (i == data_fds[1]) || (i == server->localClient->fd)) 
+			if((i == ctrl_fds[1]) || (i == data_fds[1])
+			   || (i == server->localClient->fd))
 			{
 				comm_set_nb(i);
 			}
@@ -1402,16 +1393,14 @@
 		{
 			report_error(NONB_ERROR_MSG,
 					get_server_name(server, SHOW_IP),
-					log_client_name(server, SHOW_IP),
-					errno);
+				     log_client_name(server, SHOW_IP), errno);
 		}
 
 		if(!comm_set_nb(server->localClient->ctrlfd))
 		{
 			report_error(NONB_ERROR_MSG,
 					get_server_name(server, SHOW_IP),
-					log_client_name(server, SHOW_IP),
-					errno);
+				     log_client_name(server, SHOW_IP), errno);
 		}
 
 		fd_open(server->localClient->ctrlfd, FD_SOCKET, NULL);
@@ -1469,7 +1458,7 @@
 		return 0;
 
 	/* log */
-	inetntop_sock((struct sockaddr *)&server_p->ipnum, buf, sizeof(buf));
+	inetntop_sock((struct sockaddr *) &server_p->ipnum, buf, sizeof(buf));
 	ilog(L_SERVER, "Connect to *[%s] @%s", server_p->name, buf);
 
 	/*
@@ -1517,16 +1506,14 @@
 	{
 		report_error(NONB_ERROR_MSG,
 				get_server_name(client_p, SHOW_IP),
-				log_client_name(client_p, SHOW_IP),
-				errno);
+			     log_client_name(client_p, SHOW_IP), errno);
 	}
 
 	if(!comm_set_buffers(client_p->localClient->fd, READBUF_SIZE))
 	{
 		report_error(SETBUF_ERROR_MSG,
 				get_server_name(client_p, SHOW_IP),
-				log_client_name(client_p, SHOW_IP),
-				errno);
+			     log_client_name(client_p, SHOW_IP), errno);
 	}
 
 	/*
@@ -1566,14 +1553,14 @@
 	if(ServerConfVhosted(server_p))
 	{
 		memcpy(&myipnum, &server_p->my_ipnum, sizeof(myipnum));
-		((struct sockaddr_in *)&myipnum)->sin_port = 0;
+		((struct sockaddr_in *) &myipnum)->sin_port = 0;
 		myipnum.ss_family = server_p->my_ipnum.ss_family;
 				
 	}
 	else if(server_p->ipnum.ss_family == AF_INET && ServerInfo.specific_ipv4_vhost)
 	{
 		memcpy(&myipnum, &ServerInfo.ip, sizeof(myipnum));
-		((struct sockaddr_in *)&myipnum)->sin_port = 0;
+		((struct sockaddr_in *) &myipnum)->sin_port = 0;
 		myipnum.ss_family = AF_INET;
 		SET_SS_LEN(myipnum, sizeof(struct sockaddr_in));
 	}
@@ -1582,7 +1569,7 @@
 	else if((server_p->ipnum.ss_family == AF_INET6) && ServerInfo.specific_ipv6_vhost)
 	{
 		memcpy(&myipnum, &ServerInfo.ip6, sizeof(myipnum));
-		((struct sockaddr_in6 *)&myipnum)->sin6_port = 0;
+		((struct sockaddr_in6 *) &myipnum)->sin6_port = 0;
 		myipnum.ss_family = AF_INET6;
 		SET_SS_LEN(myipnum, sizeof(struct sockaddr_in6));
 	}
@@ -1630,17 +1617,18 @@
 #ifdef IPV6
 	if(fd_table[fd].connect.hostaddr.ss_family == AF_INET6)
 	{
-		struct sockaddr_in6 *lip = (struct sockaddr_in6 *)&client_p->localClient->ip;
-		struct sockaddr_in6 *hip = (struct sockaddr_in6 *)&fd_table[fd].connect.hostaddr;	
+		struct sockaddr_in6 *lip = (struct sockaddr_in6 *) &client_p->localClient->ip;
+		struct sockaddr_in6 *hip = (struct sockaddr_in6 *) &fd_table[fd].connect.hostaddr;
 		memcpy(&lip->sin6_addr, &hip->sin6_addr, sizeof(struct in6_addr));
 		SET_SS_LEN(client_p->localClient->ip, sizeof(struct sockaddr_in6));
 		SET_SS_LEN(fd_table[fd].connect.hostaddr, sizeof(struct sockaddr_in6));
 
-	} else
+	}
+	else
 #else
 	{
-		struct sockaddr_in *lip = (struct sockaddr_in *)&client_p->localClient->ip;
-		struct sockaddr_in *hip = (struct sockaddr_in *)&fd_table[fd].connect.hostaddr;	
+		struct sockaddr_in *lip = (struct sockaddr_in *) &client_p->localClient->ip;
+		struct sockaddr_in *hip = (struct sockaddr_in *) &fd_table[fd].connect.hostaddr;
 		lip->sin_addr.s_addr = hip->sin_addr.s_addr;
 		SET_SS_LEN(client_p->localClient->ip, sizeof(struct sockaddr_in));
 		SET_SS_LEN(fd_table[fd].connect.hostaddr, sizeof(struct sockaddr_in));
@@ -1655,8 +1643,7 @@
 		 */
 		if(status == COMM_ERR_TIMEOUT)
 			sendto_realops_flags(UMODE_ALL, L_ALL,
-					"Error connecting to %s[%s]: %s",
-					client_p->name, 
+					     "Error connecting to %s[%s]: %s", client_p->name,
 #ifdef HIDE_SERVERS_IPS
 					"255.255.255.255",
 #else
@@ -1665,8 +1652,7 @@
 					comm_errstr(status));
 		else
 			sendto_realops_flags(UMODE_ALL, L_ALL,
-					"Error connecting to %s[%s]: %s (%s)",
-					client_p->name,
+					     "Error connecting to %s[%s]: %s (%s)", client_p->name,
 #ifdef HIDE_SERVERS_IPS
 					"255.255.255.255",
 #else
@@ -1700,8 +1686,7 @@
 			sendto_one(client_p, "PASS %s TS %d :%s", 
 				   server_p->spasswd, TS_CURRENT, me.id);
 		else
-			sendto_one(client_p, "PASS %s :TS",
-				   server_p->spasswd);
+			sendto_one(client_p, "PASS %s :TS", server_p->spasswd);
 	}
 
 	/* pass my info to the new server */
@@ -1710,8 +1695,7 @@
 			  | (ServerConfTb(server_p) ? CAP_TB : 0));
 
 	sendto_one(client_p, "SERVER %s 1 :%s%s",
-		   me.name,
-		   ConfigServerHide.hidden ? "(H) " : "", me.info);
+		   me.name, ConfigServerHide.hidden ? "(H) " : "", me.info);
 
 	/* 
 	 * If we've been marked dead because a send failed, just exit
@@ -1748,13 +1732,15 @@
 		errno = EAFNOSUPPORT;
 		return -1;
 	}
-	if(((sv[0] = socket(AF_INET, SOCK_STREAM, 0)) < 0) || ((sv[1] = socket(AF_INET, SOCK_STREAM, 0)) < 0))
+	if(((sv[0] = socket(AF_INET, SOCK_STREAM, 0)) < 0)
+	   || ((sv[1] = socket(AF_INET, SOCK_STREAM, 0)) < 0))
 		return -1;
 	
 	addr1.sin_port = htons(port_no);
 	addr1.sin_family = AF_INET;
 	addr1.sin_addr.s_addr = htonl(INADDR_LOOPBACK);
-	while ((rc = bind (sv[0], (struct sockaddr *) &addr1, sizeof (addr1))) < 0 && errno == EADDRINUSE)
+	while((rc = bind(sv[0], (struct sockaddr *) &addr1, sizeof(addr1))) < 0
+	      && errno == EADDRINUSE)
 		addr1.sin_port = htons(++port_no);
 	
 	if(rc < 0)
@@ -1770,7 +1756,7 @@
 	addr2.sin_port = htons(port_no);
 	addr2.sin_family = AF_INET;
 	addr2.sin_addr.s_addr = htonl(INADDR_LOOPBACK);
-	if(connect (sv[1], (struct sockaddr *) &addr2, sizeof (addr2)) < 0) 
+	if(connect(sv[1], (struct sockaddr *) &addr2, sizeof(addr2)) < 0)
 	{
 		close(sv[0]);
 		close(sv[1]);
@@ -1786,7 +1772,7 @@
 	close(sv[0]);
 	sv[0] = fd;
 	
-	return(0);
+	return (0);
 
 }
 #endif
Index: src/s_stats.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/src/Attic/s_stats.c,v
retrieving revision 7.36.2.1
diff -b -u -r7.36.2.1 s_stats.c
--- src/s_stats.c	4 Aug 2004 00:21:17 -0000	7.36.2.1
+++ src/s_stats.c	19 Aug 2004 22:16:44 -0000
@@ -125,37 +125,26 @@
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			"T :rejected %u delaying %lu", 
 			sp->is_rej, dlink_list_length(&delay_exit));
+	sendto_one_numeric(source_p, RPL_STATSDEBUG, "T :nicks being delayed %lu", get_nd_count());
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			"T :nicks being delayed %lu",
-			get_nd_count());
+			   "T :unknown commands %u prefixes %u", sp->is_unco, sp->is_unpf);
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "T :unknown commands %u prefixes %u",
-			   sp->is_unco, sp->is_unpf);
+			   "T :nick collisions %u unknown closes %u", sp->is_kill, sp->is_ni);
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "T :nick collisions %u unknown closes %u",
-			   sp->is_kill, sp->is_ni);
+			   "T :wrong direction %u empty %u", sp->is_wrdi, sp->is_empt);
+	sendto_one_numeric(source_p, RPL_STATSDEBUG, "T :numerics seen %u", sp->is_num);
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "T :wrong direction %u empty %u", 
-			   sp->is_wrdi, sp->is_empt);
-	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "T :numerics seen %u", sp->is_num);
-	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "T :auth successes %u fails %u",
-			   sp->is_asuc, sp->is_abad);
+			   "T :auth successes %u fails %u", sp->is_asuc, sp->is_abad);
 	sendto_one_numeric(source_p, RPL_STATSDEBUG, "T :Client Server");
-	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "T :connected %u %u", sp->is_cl, sp->is_sv);
+	sendto_one_numeric(source_p, RPL_STATSDEBUG, "T :connected %u %u", sp->is_cl, sp->is_sv);
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			   "T :bytes sent %d.%uK %d.%uK",
-			   (int) sp->is_cks, sp->is_cbs, 
-			   (int) sp->is_sks, sp->is_sbs);
+			   (int) sp->is_cks, sp->is_cbs, (int) sp->is_sks, sp->is_sbs);
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			   "T :bytes recv %d.%uK %d.%uK",
-			   (int) sp->is_ckr, sp->is_cbr, 
-			   (int) sp->is_skr, sp->is_sbr);
+			   (int) sp->is_ckr, sp->is_cbr, (int) sp->is_skr, sp->is_sbr);
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "T :time connected %d %d",
-			   (int) sp->is_cti, (int) sp->is_sti);
+			   "T :time connected %d %d", (int) sp->is_cti, (int) sp->is_sti);
 }
 
 void
@@ -295,31 +284,25 @@
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			   "z :Classes %u(%lu)",
-			   class_count, 
-			   (unsigned long) class_count * sizeof(struct Class));
+			   class_count, (unsigned long) class_count * sizeof(struct Class));
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "z :Channels %u(%d)",
-			   channel_count, (int) channel_memory);
+			   "z :Channels %u(%d)", channel_count, (int) channel_memory);
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "z :Bans %u(%d)",
-			   channel_bans, (int) channel_ban_memory);
+			   "z :Bans %u(%d)", channel_bans, (int) channel_ban_memory);
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "z :Exceptions %u(%d)",
-			   channel_except, (int) channel_except_memory);
+			   "z :Exceptions %u(%d)", channel_except, (int) channel_except_memory);
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "z :Invex %u(%d)",
-			   channel_invex, (int) channel_invex_memory);
+			   "z :Invex %u(%d)", channel_invex, (int) channel_invex_memory);
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			   "z :Channel members %u(%lu) invite %u(%lu)",
 			   channel_users,
 			   (unsigned long) channel_users * sizeof(dlink_node),
-			   channel_invites, 
-			   (unsigned long) channel_invites * sizeof(dlink_node));
+			   channel_invites, (unsigned long) channel_invites * sizeof(dlink_node));
 
 	total_channel_memory = channel_memory +
 		channel_ban_memory +
@@ -327,32 +310,30 @@
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			   "z :Whowas users %ld(%ld)",
-			   (long)wwu, (long) (wwu * sizeof(struct User)));
+			   (long) wwu, (long) (wwu * sizeof(struct User)));
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "z :Whowas array %u(%d)",
-			   NICKNAMEHISTORYLENGTH, (int) wwm);
+			   "z :Whowas array %u(%d)", NICKNAMEHISTORYLENGTH, (int) wwm);
 
 	totww = wwu * sizeof(struct User) + wwm;
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			   "z :Hash: client %u(%ld) chan %u(%ld)",
-			   U_MAX, (long)(U_MAX * sizeof(dlink_list)), 
-			   CH_MAX, (long)(CH_MAX * sizeof(dlink_list)));
+			   U_MAX, (long) (U_MAX * sizeof(dlink_list)),
+			   CH_MAX, (long) (CH_MAX * sizeof(dlink_list)));
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
-			   "z :linebuf %ld(%ld)",
-			   (long)linebuf_count, (long)linebuf_memory_used);
+			   "z :linebuf %ld(%ld)", (long) linebuf_count, (long) linebuf_memory_used);
 
 	count_scache(&number_servers_cached, &mem_servers_cached);
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			   "z :scache %ld(%ld)",
-			   (long)number_servers_cached, (long)mem_servers_cached);
+			   (long) number_servers_cached, (long) mem_servers_cached);
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			   "z :hostname hash %d(%ld)",
-			   HOST_MAX, (long)HOST_MAX * sizeof(dlink_list));
+			   HOST_MAX, (long) HOST_MAX * sizeof(dlink_list));
 
 	total_memory = totww + total_channel_memory + conf_memory +
 		class_count * sizeof(struct Class);
@@ -360,15 +341,14 @@
 	total_memory += mem_servers_cached;
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			   "z :Total: whowas %d channel %d conf %d", 
-			   (int) totww, (int) total_channel_memory, 
-			   (int) conf_memory);
+			   (int) totww, (int) total_channel_memory, (int) conf_memory);
 
 	count_local_client_memory(&local_client_count, &local_client_memory_used);
 	total_memory += local_client_memory_used;
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			   "z :Local client Memory in use: %ld(%ld)",
-			   (long)local_client_count, (long)local_client_memory_used);
+			   (long) local_client_count, (long) local_client_memory_used);
 
 
 	count_remote_client_memory(&remote_client_count, &remote_client_memory_used);
@@ -376,8 +356,7 @@
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			   "z :Remote client Memory in use: %ld(%ld)",
-			   (long)remote_client_count,
-			   (long)remote_client_memory_used);
+			   (long) remote_client_count, (long) remote_client_memory_used);
 
 	sendto_one_numeric(source_p, RPL_STATSDEBUG,
 			   "z :TOTAL: %d Available:  Current max RSS: %lu",
Index: src/s_user.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/src/s_user.c,v
retrieving revision 7.323.2.2
diff -b -u -r7.323.2.2 s_user.c
--- src/s_user.c	3 Aug 2004 20:39:52 -0000	7.323.2.2
+++ src/s_user.c	19 Aug 2004 22:16:45 -0000
@@ -178,13 +178,11 @@
 			   Count.invisi, dlink_list_length(&global_serv_list));
 
 	if(Count.oper > 0)
-		sendto_one_numeric(source_p, RPL_LUSEROP, 
-				   form_str(RPL_LUSEROP), Count.oper);
+		sendto_one_numeric(source_p, RPL_LUSEROP, form_str(RPL_LUSEROP), Count.oper);
 
 	if(dlink_list_length(&unknown_list) > 0)
 		sendto_one_numeric(source_p, RPL_LUSERUNKNOWN, 
-				   form_str(RPL_LUSERUNKNOWN),
-				   dlink_list_length(&unknown_list));
+				   form_str(RPL_LUSERUNKNOWN), dlink_list_length(&unknown_list));
 
 	if(dlink_list_length(&global_channel_list) > 0)
 		sendto_one_numeric(source_p, RPL_LUSERCHANNELS, 
@@ -192,27 +190,24 @@
 				   dlink_list_length(&global_channel_list));
 
 	sendto_one_numeric(source_p, RPL_LUSERME, form_str(RPL_LUSERME),
-			   dlink_list_length(&lclient_list),
-			   dlink_list_length(&serv_list));
+			   dlink_list_length(&lclient_list), dlink_list_length(&serv_list));
 
 	sendto_one_numeric(source_p, RPL_LOCALUSERS, 
 			   form_str(RPL_LOCALUSERS),
-			   dlink_list_length(&lclient_list),
-			   Count.max_loc);
+			   dlink_list_length(&lclient_list), Count.max_loc);
 
 	sendto_one_numeric(source_p, RPL_GLOBALUSERS, form_str(RPL_GLOBALUSERS),
 			   Count.total, Count.max_tot);
 
 	sendto_one_numeric(source_p, RPL_STATSCONN,
 			   form_str(RPL_STATSCONN),
-			   MaxConnectionCount, MaxClientCount, 
-			   Count.totalrestartcount);
+			   MaxConnectionCount, MaxClientCount, Count.totalrestartcount);
 
-	if(dlink_list_length(&lclient_list) > (unsigned long)MaxClientCount)
+	if(dlink_list_length(&lclient_list) > (unsigned long) MaxClientCount)
 		MaxClientCount = dlink_list_length(&lclient_list);
 
 	if((dlink_list_length(&lclient_list) + dlink_list_length(&serv_list)) >
-	   (unsigned long)MaxConnectionCount)
+	   (unsigned long) MaxConnectionCount)
 		MaxConnectionCount = dlink_list_length(&lclient_list) + 
 					dlink_list_length(&serv_list);
 
@@ -266,13 +261,14 @@
 */
 
 int
-register_local_user(struct Client *client_p, struct Client *source_p, const char *nick, const char *username)
+register_local_user(struct Client *client_p, struct Client *source_p, const char *nick,
+		    const char *username)
 {
 	struct ConfItem *aconf;
 	struct User *user = source_p->user;
 	char tmpstr2[IRCD_BUFSIZE];
 	char ipaddr[HOSTIPLEN];
-	char myusername[USERLEN+1];
+	char myusername[USERLEN + 1];
 	int status;
 
 	s_assert(NULL != source_p);
@@ -374,7 +370,7 @@
 			if(!IsNoTilde(aconf))
 				source_p->username[i++] = '~';
 
-			while (*p && i < USERLEN)
+			while(*p && i < USERLEN)
 			{
 				if(*p != '[')
 					source_p->username[i++] = *p;
@@ -426,9 +422,9 @@
 	 */
 	/* Except "F:" clients */
 	if(((dlink_list_length(&lclient_list) + 1) >= 
-	   ((unsigned long)GlobalSetOptions.maxclients + MAX_BUFFER) ||
+	    ((unsigned long) GlobalSetOptions.maxclients + MAX_BUFFER) ||
            (dlink_list_length(&lclient_list) + 1) >= 
-	    ((unsigned long)GlobalSetOptions.maxclients - 5)) && !(IsExemptLimits(source_p)))
+	    ((unsigned long) GlobalSetOptions.maxclients - 5)) && !(IsExemptLimits(source_p)))
 	{
 		sendto_realops_flags(UMODE_FULL, L_ALL,
 				     "Too many clients, rejecting %s[%s].", nick, source_p->host);
@@ -454,8 +450,7 @@
 	/* end of valid user name check */
 
 	/* kline exemption extends to xline too */
-	if(!IsExemptKline(source_p) &&
-	   find_xline(source_p->info, 1) != NULL)
+	if(!IsExemptKline(source_p) && find_xline(source_p->info, 1) != NULL)
 	{
 		ServerStats->is_ref++;
 		add_reject(source_p);
@@ -472,7 +467,7 @@
 	if(IsAnyDead(client_p))
 		return CLIENT_EXITED;
 
-	inetntop_sock((struct sockaddr *)&source_p->localClient->ip, ipaddr, sizeof(ipaddr));
+	inetntop_sock((struct sockaddr *) &source_p->localClient->ip, ipaddr, sizeof(ipaddr));
 
 	sendto_realops_flags(UMODE_CCONN, L_ALL,
 			     "Client connecting: %s (%s@%s) [%s] {%s} [%s]",
@@ -511,7 +506,7 @@
 
 	s_assert(source_p->localClient != NULL);
 
-	if(dlink_list_length(&lclient_list) > (unsigned long)Count.max_loc)
+	if(dlink_list_length(&lclient_list) > (unsigned long) Count.max_loc)
 	{
 		Count.max_loc = dlink_list_length(&lclient_list);
 		if(!(Count.max_loc % 10))
@@ -533,7 +528,8 @@
  *		  from a remote connect.
  */
 int
-introduce_client(struct Client *client_p, struct Client *source_p, struct User *user, const char *nick)
+introduce_client(struct Client *client_p, struct Client *source_p, struct User *user,
+		 const char *nick)
 {
 	static char ubuf[12];
 
@@ -559,7 +555,8 @@
 			sockhost[0] = '0';
 			sockhost[1] = '\0';
 			strlcat(sockhost, source_p->sockhost, sizeof(sockhost));
-		} else
+		}
+		else
 			strcpy(sockhost, source_p->sockhost);
 		
 		sendto_server(client_p, NULL, CAP_TS6, NOCAPS,
@@ -568,8 +565,7 @@
 			      source_p->hopcount + 1,
 			      (long) source_p->tsinfo, ubuf,
 			      source_p->username, source_p->host,
-			      IsIPSpoof(source_p) ? "0" : sockhost,
-			      source_p->id, source_p->info);
+			      IsIPSpoof(source_p) ? "0" : sockhost, source_p->id, source_p->info);
 
 		sendto_server(client_p, NULL, NOCAPS, CAP_TS6,
 			      "NICK %s %d %ld %s %s %s %s :%s",
@@ -614,7 +610,7 @@
 	if('.' == *p || ':' == *p)
 		return NO;
 
-	while (*p)
+	while(*p)
 	{
 		if(!IsHostChar(*p))
 			return NO;
@@ -624,7 +620,7 @@
 	}
 
 	if(found_sep == 0)
-		return(NO);
+		return (NO);
 
 	return (YES);
 }
@@ -662,7 +658,7 @@
 	if(!IsAlNum(*p))
 		return NO;
 
-	while (*++p)
+	while(*++p)
 	{
 		if((*p == '.') && ConfigFileEntry.dots_in_ident)
 		{
@@ -821,7 +817,7 @@
 		m = buf;
 		*m++ = '+';
 
-		for (i = 0; user_modes[i].letter && (m - buf < BUFSIZE - 4); i++)
+		for(i = 0; user_modes[i].letter && (m - buf < BUFSIZE - 4); i++)
 			if(source_p->umodes & user_modes[i].mode)
 				*m++ = user_modes[i].letter;
 		*m = '\0';
@@ -835,8 +831,8 @@
 	/*
 	 * parse mode change string(s)
 	 */
-	for (p = &parv[2]; p && *p; p++)
-		for (pm = *p; *pm; pm++)
+	for(p = &parv[2]; p && *p; p++)
+		for(pm = *p; *pm; pm++)
 			switch (*pm)
 			{
 			case '+':
@@ -966,7 +962,7 @@
 	m = umode_buf;
 	*m = '\0';
 
-	for (i = 0; user_modes[i].letter; i++)
+	for(i = 0; user_modes[i].letter; i++)
 	{
 		flag = user_modes[i].mode;
 
@@ -1023,8 +1019,7 @@
 		if((target_p != client_p) && (target_p != source_p) && (*buf))
 		{
 			sendto_one(target_p, ":%s MODE %s :%s",
-				   get_id(source_p, target_p), 
-				   get_id(source_p, target_p), buf);
+				   get_id(source_p, target_p), get_id(source_p, target_p), buf);
 		}
 	}
 
@@ -1065,8 +1060,7 @@
 			   "NOTICE %s :*** Notice -- Please read the motd if you haven't read it",
 			   source_p->name);
 
-		sendto_one(source_p, form_str(RPL_MOTDSTART), 
-			   me.name, source_p->name, me.name);
+		sendto_one(source_p, form_str(RPL_MOTDSTART), me.name, source_p->name, me.name);
 
 		sendto_one(source_p, form_str(RPL_MOTD),
 			   me.name, source_p->name, "*** This is the short motd ***");
